package org.rakura.rsupdater;

@SuppressWarnings("serial")
public class IdentificationCollisionException extends RuntimeException {

	public static enum CollisionType {

		CLASS {
			@Override
			public String toString() {
				return "Class Identification Collision";
			}
		},
		FIELD {
			@Override
			public String toString() {
				return "Field Identification Collision";
			}
		};

	}

	public IdentificationCollisionException(CollisionType collisionType,
			String identification) {
		super(String.format("{%s} Identification: %s", collisionType,
				identification));
	}

}