package org.rakura.rsupdater.identifiers;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

import org.objectweb.asm.tree.ClassNode;
import org.rakura.rsupdater.Accessor;
import org.rakura.rsupdater.FieldHolder;
import org.rakura.rsupdater.util.Association;

public class Identifications {

	private Association<ClassNode, Accessor> classIdentification = new Association<ClassNode, Accessor>();
	private ConcurrentMap<String, FieldHolder> fieldIdentifications = new ConcurrentHashMap<String, FieldHolder>();

	public void identifyField(FieldHolder field, String realName) {
		fieldIdentifications.put(realName, field);
	}

	public Map<String, FieldHolder> getFieldIdentifications() {
		return fieldIdentifications;
	}

	public void identifyClass(ClassNode classNode, Accessor accessor) {
		classIdentification.associate(classNode, accessor);
	}

	public Association<ClassNode, Accessor> getClassIdentification() {
		return classIdentification;
	}

}