package org.rakura.rsupdater.transformers;

import java.util.Set;
import java.util.concurrent.CopyOnWriteArraySet;

import org.objectweb.asm.tree.ClassNode;
import org.objectweb.asm.tree.MethodNode;
import org.rakura.rsupdater.Accessor;
import org.rakura.rsupdater.GlobalVariables;

public abstract class RSTransformer implements Runnable {

	protected static final Set<ClassNode> CLASSES = new CopyOnWriteArraySet<ClassNode>(
			GlobalVariables.INSTANCE.getClasses());

	public final RSTransformerManifest ANNOTATION = getClass().getAnnotation(
			RSTransformerManifest.class);

	/*
	 * TODO: Verify validity of
	 */
	protected static void renameMethod(MethodNode methodNode, String nameTo) {
		methodNode.name = nameTo;
	}

	/*
	 * TODO: Verify validity of
	 */
	protected static void setSuperClass(ClassNode classNode,
			String superInternalName) {
		classNode.superName = superInternalName;
	}

	@SuppressWarnings("unchecked")
	protected static void implementInterface(ClassNode classNode,
			String $interface) {
		classNode.interfaces.add(Accessor.PACKAGE + $interface);
	}

	protected void implementInterface(ClassNode classNode) {
		implementInterface(classNode, ANNOTATION.accessor());
	}

}